classdef problem_c
    properties
        name string

        d uint8
        B (:, 2) double
        Ih
        oblst
        g

        %
        Tmax
    end

    methods
        function pc = problem_c(name, B, Ih, oblst, Tmax)
            arguments
                name
                B
                Ih
                oblst
                Tmax
            end
            pc.name = name;
            pc.d = length(B);
            pc.B = B;
            pc.Ih = Ih;
            pc.oblst = oblst;
            if numel(oblst) == 0
                pc.g = @(x, t) ones(1, width(x)); %1>0
            elseif numel(oblst) == 1 %#ok<ISCL>
                pc.g = oblst{1};
            else
                pc.g = @(x, t) min(cell2mat(arrayfun(@(j) pc.oblst{j}(x, t), 1:numel(pc.oblst), 'UniformOutput', false)'));
            end

            pc.Tmax = Tmax;
        end

        function p = discretize(pc, h)
            p = problem(pc, h);
        end
    end
end